#!/usr/bin/perl

require 'conf.pl';

print "Content-type: text/html\n\n";

$ip = $ENV{'REMOTE_ADDR'};
$rhost = gethostbyaddr(pack("C4", split(/\./, $ip)), 2);
if ($rhost eq '') {
$rhost = $ENV{'REMOTE_HOST'};
}
$bro = $ENV{'HTTP_USER_AGENT'};
$week = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat')[(localtime(time))[6]];
($sec, $fun, $hour, $mday, $mon, $year, $zz, $xx, $cc) = localtime(time+$d_time);
$monn = $mon + 1;
$year = $year + 1900;

if ($monn == 1) { $monn = "Jan"; }
if ($monn == 2) { $monn = "Feb"; }
if ($monn == 3) { $monn = "Mar"; }
if ($monn == 4) { $monn = "Apr"; }
if ($monn == 5) { $monn = "May"; }
if ($monn == 6) { $monn = "Jun"; }
if ($monn == 7) { $monn = "Jul"; }
if ($monn == 8) { $monn = "Aug"; }
if ($monn == 9) { $monn = "Sep"; }
if ($monn == 10) { $monn = "Oct"; }
if ($monn == 11) { $monn = "Nov"; }
if ($monn == 12) { $monn = "Dec"; }

$request_method = $ENV{'REQUEST_METHOD'};

if ($request_method eq "GET") {
$buffer = $ENV{'QUERY_STRING'};
} else {
$size_of_form_infomation = $ENV{'CONTENT_LENGTH'};
read (STDIN, $buffer, $size_of_form_infomation);
}

@pairs = split(/&/, $buffer);
foreach $pair (@pairs)
{
($name, $value) = split(/=/, $pair);
$value =~ tr/+/ /;
$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$FORM{$name} = $value;
}
$oldkey = $FORM{'oldkey'};
$newkey = $FORM{'newkey'};
$morekey = $FORM{'morekey'};

if ($oldkey eq '' && $newkey eq '' && $morekey eq '') {
print "$doct\n$htmlst\n<head>\n$header\n<title>Create or change the password for management</title>\n</head>\n";
print "<body>\n$start_of_html\n";
print "<h1>Create or change the password for management</h1>\n";
print "You can determine the password for management here.<br>\n";
print "If the password for management is used, various operations will be enabled in this BBS.<br>\n";
print "Set up the password which is hard to guess in order to prevent abuse by a third person.<br>\n<hr>\n";
print "<form action=\"adpasswd.cgi\" method=\"POST\">\n";
print "Current password:<input type=\"password\" name=\"oldkey\" size=\"10\">\n";
print "<font size=\"1\">(You may empty this, if you create a password for the first time.)</font><br>\n";
print "New password:<input type=\"password\" name=\"newkey\" size=\"10\"><br>\n";
print "Input a new password once again for a check:";
print "<input type=\"password\" name=\"morekey\" size=\"10\"><br>\n";
print "<input type=\"submit\" value=\"Create or change the password for management\">\n";
print "</form>\n";
print "$end_of_html\n</body>\n</html>";
exit(0);
}

if ($morekey ne $newkey) {

print "$doct\n$htmlst\n<head>\n$header\n<title>The password was not changed</title>\n</head>\n";
print "<body>\n$start_of_html\n";
print "<h1>The password for a check is not matching</h1>\n<hr>\n";
print "<a href=\"admin.html\">Go back</a>\n";
print "$end_of_html\n</body>\n</html>";
exit(0);
}

if (!open(IN, "$passdir/admin.pass")) {
$nowpasswd = "";
} else {
$nowpasswd = <IN>;
close(IN);
}

if ($nowpasswd ne '') {
$oldpasswd = crypt($oldkey, $nowpasswd);
}

if ($oldpasswd eq $nowpasswd || $nowpasswd eq '') {
$salt = &createSalt;

sub createSalt {
local( $salt_paire, $salt1, $salt2, $salt);

$salt_paire = 
    "./0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
    
    srand(time/$$);
    $salt1 = int( rand(63) );
    srand(time|$$);
    $salt2 = int( rand(63) );
    
    $salt1 = substr( $salt_paire, $salt1, 1);
    $salt2 = substr( $salt_paire, $salt2, 1);
    
    $salt = "$salt1$salt2";
    
    return ($salt);
}

$passwd = crypt($newkey, $salt);

open(OUT, ">$passdir/admin.pass");
flock(OUT, 2);
print OUT $passwd;
flock(OUT, 8);
close(OUT);

if ($remote_log == 1) {
open(OUT, ">>$logdir/log.txt");
flock(OUT, 2);
print OUT "$timezone_name $week, $monn $mday, $year $hour:$fun:$sec The password for management was changed. Remote host:$rhost($ip) Browser:$bro\n";
flock(OUT, 8);
close(OUT);
}

$message = "The password for management was changed.";
} else {

if ($remote_log == 1) {
open(OUT, ">>$logdir/log.txt");
flock(OUT, 2);
print OUT "$timezone_name $week, $monn $mday, $year $hour:$fun:$sec Changing the password for management failed. Remote host:$rhost($ip) Browser:$bro\n";
flock(OUT, 8);
close(OUT);
}

$message = "Invalid current password. The password was not changed.";
}

print "$doct\n$htmlst\n<head>\n$header\n<title>The password for management was changed</title>\n</head>\n";
print "<body>\n$start_of_html\n";
print "$message<br>\n";
print "Please delete an admin.pass file, supposing you forget a password.<br>\n<hr>\n";
print "<a href=\"admin.html\">Go back</a>\n";
print "$end_of_html\n</body>\n</html>";

