# The configuration file of TOM-BBS
# NOTICE: When you use """ and "\" here, insert "\" before a character.
# More specifically, """ should write it as "\"" and "\" should write it as "\\."
## A fundamental configuration
$title_name = "TOMBBS";			# The title of a bulletin board
$dir = "data";				# The directory on which the file for writing is put
$passdir = "password";			# The directory on which the file of a password is put
$logdir = "data";			# The directory on which the file of a log is put
$lockfile = "$dir/lock.lock";		# The path to a lock file
$walldir = "wallpapers";		# The directory on which the file of wallpaper is put
$bgc = "#ffffff";			# The color of a background
$textc = "#000000";			# The color of a text
$linkc = "#ff0000";			# The color of a link
$vlinkc = "#ff00ff";			# The color of the already visited link
$alinkc = "#ff7777";			# The color of the link when being clicked
$link_url = "http://hp.vector.co.jp/authors/VA024248/"; # URL of the link for returning
$link_name = "Go to the web site of the author of this BBS."; # Name of the link for returning
$wallp = "1.gif 2.gif 3.gif 4.gif 5.gif 6.gif 7.gif 8.gif 9.gif 0.gif"; # The list of files of wallpaper
$design = 0;                            # Display wallpaper. (0:do not 1:do -- In the case of 0, a configuration of $wallp is invalid.)
$max_point = 0;				# The maximum number of the article to save (0:unrestraint)
$remote_info = 1;			# Display the information of the person who post (0:do 1:do not)
$remote_log = 1;			# Record the information of the person who executed operation of posting etc. (0:do not 1:record a log by file name called log.txt on the directory specified in $logdir.)
$ht = 1;				# Permit inserting a HTML tag. (0:do 1:do not -- however, even if $ht = 0;, comment out of "<!-- ... >" is repudiated for security so that SSI may not be inserted.)
$duplication_guard = 1;			# Prevent a duplicate posting. (0:do not 1:do)
$forbmess = "./forbmess";		# The file of the message (HTML) to the person who forbade access.
$ENV{'TZ'} = "JST-9";			# A configuration of a time zone (For details, refer to readme.txt.)
$timezone_name = "JST";		# Display a time zone. (This is reflected on the display at BBS.)

## A configuration of a banner and a Java script (Only when you need)
## Configure, if the server administrator required you to insert a banner, and if you want to insert a Java script.
$header = "";			# HTML which should be inserted into the <head> tag
$start_of_html = "";		# HTML which should be inserted behind the <body>
$end_of_html = " ";		# HTML which should be inserted in front of a </body> (Don't make it empty! If it is made empty, an error will occur.)

## The following is a configuration which should not be changed usually. Change, only when you need.
## Usually, you should not change.
$htmlst = "<html>";		# The start of the <html> tag (You may add a lang attribute etc.)
$doct = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2 Final//EN\">";  # The version of HTML to output

